- Main Page
- Modules
- Namespaces
- Classes
- Files
- Related Pages

- Alphabetical List
- Class List
- Class Hierarchy
- Class Members

# FCDPhysicsRigidConstraint Class Reference
[COLLADA Document Object Model.]

A COLLADA rigid constraint. More...

`#include <FCDPhysicsRigidConstraint.h>`

Inheritance diagram for FCDPhysicsRigidConstraint:

List of all members.

## Public Member Functions
| FCDPhysicsRigidConstraint (FCDocument *document, FCDPhysicsModel *_parent)
| Constructor: do not use directly.
virtual | ~FCDPhysicsRigidConstraint ()
| Destructor.
virtual Type | GetType () const
| Retrieves the entity type for this class.
FCDPhysicsModel * | GetParent ()
| Retrieves the physics model that contraints this rigid constraint.
const FCDPhysicsModel * | GetParent () const
| See above.
const fm::string & | GetSubId () const
| Retrieves the wanted sub-id for this transform.
void | SetSubId (const fm::string &subId)
| Sets the wanted sub-id for this transform.
void | SetSubId (const char *subId)
| See above.
FCDPhysicsRigidBody * | GetReferenceRigidBody ()
| Retrieves the attached rigid body which is the reference.
const FCDPhysicsRigidBody * | GetReferenceRigidBody () const
| See above.
void | SetReferenceRigidBody (FCDPhysicsRigidBody *_referenceRigidBody)
| Sets the attached rigid body which is the reference.
FCDPhysicsRigidBody * | GetTargetRigidBody ()
| Retrieves the attached rigid body which is not the reference.
const FCDPhysicsRigidBody * | GetTargetRigidBody () const
| See above.
void | SetTargetRigidBody (FCDPhysicsRigidBody *_targetRigidBody)
| Sets the attached rigid body which is not the reference.
FCDSceneNode * | GetReferenceNode ()
| Retrieves the attached node which is the reference.
const FCDSceneNode * | GetReferenceNode () const
| See above.
void | SetReferenceNode (FCDSceneNode *_referenceNode)
| Sets the attached node which is the reference.
FCDSceneNode * | GetTargetNode ()
| Retrieves the attached node which is not the reference.
const FCDSceneNode * | GetTargetNode () const
| See above.
void | SetTargetNode (FCDSceneNode *_targetNode)
| Sets the attached node which is not the reference.
FCDTransformContainer & | GetTransformsRef ()
| Retrieves the transforms for the attached rigid body which is the reference.
const FCDTransformContainer & | GetTransformsRef () const
| See above.
FCDTransformContainer & | GetTransformsTar ()
| Retrieves the transforms for the attached rigid body which is not the reference.
const FCDTransformContainer & | GetTransformsTar () const
| See above.
FCDTransform * | AddTransformRef (FCDTransform::Type type, size_t index=(size_t)-1)
| Adds a transform for the attached rigid body which is the reference.
FCDTransform * | AddTransformTar (FCDTransform::Type type, size_t index=(size_t)-1)
| Adds a transform for the attached rigid body which is not the reference.
FCDParameterAnimatableFloat & | GetEnabled ()
| Retrieves whether this rigid constraint is enabled.
const FCDParameterAnimatableFloat & | GetEnabled () const
| See above.
bool | IsEnabled () const
| See above.
void | SetEnabled (bool _enabled)
| Sets whether this rigid constraint is enabled.
FCDParameterAnimatableFloat & | GetInterpenetrate ()
| Retrieves whether the connected rigid bodies can penetrate eachother.
const FCDParameterAnimatableFloat & | GetInterpenetrate () const
| See above.
bool | IsInterpenetrate () const
| See above.
void | SetInterpenetrate (bool _interpenetrate)
| Sets whether the connected rigid bodies can penetrate eachother.
FUParameterVector3 & | GetLimitsLinearMin ()
| Retrieves the linear min limit of the degrees of freedom.
const FUParameterVector3 & | GetLimitsLinearMin () const
| See above.
void | SetLimitsLinearMin (const FMVector3 &_limitsLinearMin)
| Sets the linear min limit of the degrees of freedom.
FUParameterVector3 & | GetLimitsLinearMax ()
| Retrieves the linear max limit of the degrees of freedom.
const FUParameterVector3 & | GetLimitsLinearMax () const
| See above.
void | SetLimitsLinearMax (const FMVector3 &_limitsLinearMax)
| Sets the linear max limit of the degrees of freedom.
FUParameterVector3 & | GetLimitsSCTMin ()
| Retrieves the swing cone and twist min limit of the degrees of freedom.
const FUParameterVector3 & | GetLimitsSCTMin () const
| See above.
void | SetLimitsSCTMin (const FMVector3 &_limitsSCTMin)
| Sets the swing cone and twist min limit of the degrees of freedom.
FUParameterVector3 & | GetLimitsSCTMax ()
| Retrieves the swing cone and twist max limit of the degrees of freedom.
const FUParameterVector3 & | GetLimitsSCTMax () const
| See above.
void | SetLimitsSCTMax (const FMVector3 &_limitsSCTMax)
| Sets the swing cone and twist max limit of the degrees of freedom.
FUParameterFloat & | GetSpringLinearStiffness ()
| Retrieves the spring linear stiffness of the spring rigid constraint.
const FUParameterFloat & | GetSpringLinearStiffness () const
| See above.
void | SetSpringLinearStiffness (float _springLinearStiffness)
| Sets the spring linear stiffness of the spring rigid constraint.
FUParameterFloat & | GetSpringLinearDamping ()
| Retrieves the spring linear damping of the spring rigid constraint.
const FUParameterFloat & | GetSpringLinearDamping () const
| See above.
void | SetSpringLinearDamping (float _springLinearDamping)
| Sets the spring linear damping of the spring rigid constraint.
FUParameterFloat & | GetSpringLinearTargetValue ()
| Retrieves the sping linear target value of the spring rigid constraint.
const FUParameterFloat & | GetSpringLinearTargetValue () const
| See above.
void | SetSpringLinearTargetValue (float _springLinearTargetValue)
| Sets the sping linear target value of the spring rigid constraint.
FUParameterFloat & | GetSpringAngularStiffness ()
| Retrieves the spring angular stiffness of the spring rigid constraint.
const FUParameterFloat & | GetSpringAngularStiffness () const
| See above.
void | SetSpringAngularStiffness (float _springAngularStiffness)
| Sets the spring angular stiffness of the spring rigid constraint.
FUParameterFloat & | GetSpringAngularDamping ()
| Retrieves the spring angular damping of the spring rigid constraint.
const FUParameterFloat & | GetSpringAngularDamping () const
| See above.
void | SetSpringAngularDamping (float _springAngularDamping)
| Sets the spring angular damping of the spring rigid constraint.
FUParameterFloat & | GetSpringAngularTargetValue ()
| Retrieves the sping angular target value of the spring rigid constraint.
const FUParameterFloat & | GetSpringAngularTargetValue () const
| See above.
void | SetSpringAngularTargetValue (float _springAngularTargetValue)
| Sets the sping angular target value of the spring rigid constraint.
| DEPRECATED (3.05A, GetEnabled().GetAnimated) FCDAnimated *GetAnimatedEnabled()
| Retrieves the animated value for enabled.
| DEPRECATED (3.05A, GetEnabled().GetAnimated) const FCDAnimated *GetAnimatedEnabled() const
| See above.
| DEPRECATED (3.05A, GetInterpenetrate().GetAnimated) FCDAnimated *GetAnimatedInterpenetrate()
| Retrieves the animated value for interpenetrate.
| DEPRECATED (3.05A, GetInterpenetrate().GetAnimated) const FCDAnimated *GetAnimatedInterpenetrate() const
| See above.
virtual FCDEntity * | Clone (FCDEntity *clone=NULL, bool cloneChildren=false) const
| Copies the rigid constraint into a clone.

## Detailed Description

A COLLADA rigid constraint.

A rigid constraint attaches two rigid bodies together using springs, ball joints, or other limitations.

## Constructor & Destructor Documentation

FCDPhysicsRigidConstraint::FCDPhysicsRigidConstraint | ( | FCDocument * | document,
|  | FCDPhysicsModel * | _parent
| ) |

  | Constructor: do not use directly. Create new rigid constraints using the FCDPhysicsModel::AddRigidConstraint function. Parameters:
  | document | The COLLADA document that contains this rigid constraint.
  | _parent | The physics model that contains this rigid constraint.

## Member Function Documentation

FCDTransform* FCDPhysicsRigidConstraint::AddTransformRef | ( | FCDTransform::Type | type,
|  | size_t | index = `(size_t)-1`
| ) |

  | Adds a transform for the attached rigid body which is the reference. Parameters:
  | type | The type of transform.
  | index | The position to add the transform to.

FCDTransform* FCDPhysicsRigidConstraint::AddTransformTar | ( | FCDTransform::Type | type,
|  | size_t | index = `(size_t)-1`
| ) |

  | Adds a transform for the attached rigid body which is not the reference. Parameters:
  | type | The type of transform.
  | index | The position to add the transform to.

virtual FCDEntity* FCDPhysicsRigidConstraint::Clone | ( | FCDEntity * | clone = `NULL`,
|  | bool | cloneChildren = `false`
| ) | const`[virtual]`

  | Copies the rigid constraint into a clone. Parameters:
  | clone | The empty clone. If this pointer is NULL, a new rigid constraint will be created and you will need to release the returned pointer manually.
  | cloneChildren | Whether to recursively clone this entity's children.
Returns: The clone. Reimplemented from FCDEntity.

FCDPhysicsRigidConstraint::DEPRECATED | ( | 3. | 05A,
|  | GetInterpenetrate(). | GetAnimated
| ) | `[inline]`

| Retrieves the animated value for interpenetrate. Returns: The animated value, or NULL if interpenetrate is not animated.

FCDPhysicsRigidConstraint::DEPRECATED | ( | 3. | 05A,
|  | GetEnabled(). | GetAnimated
| ) | `[inline]`

| Retrieves the animated value for enabled. Returns: The animated value, or NULL if enabled is not animated.

FCDParameterAnimatableFloat& FCDPhysicsRigidConstraint::GetEnabled | ( |  | ) | `[inline]`

| Retrieves whether this rigid constraint is enabled. Returns: True if enabled.

FCDParameterAnimatableFloat& FCDPhysicsRigidConstraint::GetInterpenetrate | ( |  | ) | `[inline]`

| Retrieves whether the connected rigid bodies can penetrate eachother. Returns: True of they can penetrate.

FUParameterVector3& FCDPhysicsRigidConstraint::GetLimitsLinearMax | ( |  | ) | `[inline]`

| Retrieves the linear max limit of the degrees of freedom. Returns: The linear max limit.

FUParameterVector3& FCDPhysicsRigidConstraint::GetLimitsLinearMin | ( |  | ) | `[inline]`

| Retrieves the linear min limit of the degrees of freedom. Returns: The linear min limit.

FUParameterVector3& FCDPhysicsRigidConstraint::GetLimitsSCTMax | ( |  | ) | `[inline]`

| Retrieves the swing cone and twist max limit of the degrees of freedom. Returns: The swing cone and twist max limit.

FUParameterVector3& FCDPhysicsRigidConstraint::GetLimitsSCTMin | ( |  | ) | `[inline]`

| Retrieves the swing cone and twist min limit of the degrees of freedom. Returns: The swing cone and twist min limit.

FCDPhysicsModel* FCDPhysicsRigidConstraint::GetParent | ( |  | ) | `[inline]`

| Retrieves the physics model that contraints this rigid constraint. Returns: The physics model.

FCDSceneNode* FCDPhysicsRigidConstraint::GetReferenceNode | ( |  | ) | `[inline]`

| Retrieves the attached node which is the reference. This method should be avoided as the specification says the attachment should be to a rigid body. This value is only used if GetReferenceRigidBody is NULL. Returns: The attached reference node.

FCDPhysicsRigidBody* FCDPhysicsRigidConstraint::GetReferenceRigidBody | ( |  | ) | `[inline]`

| Retrieves the attached rigid body which is the reference. Returns: The reference rigid body.

FUParameterFloat& FCDPhysicsRigidConstraint::GetSpringAngularDamping | ( |  | ) | `[inline]`

| Retrieves the spring angular damping of the spring rigid constraint. This is set to 0.0 if there is no spring. Returns: The spring angular damping.

FUParameterFloat& FCDPhysicsRigidConstraint::GetSpringAngularStiffness | ( |  | ) | `[inline]`

| Retrieves the spring angular stiffness of the spring rigid constraint. This is set to 1.0 if there is no spring. Returns: The spring angular stiffness.

FUParameterFloat& FCDPhysicsRigidConstraint::GetSpringAngularTargetValue | ( |  | ) | `[inline]`

| Retrieves the sping angular target value of the spring rigid constraint. This is set to 0.0 if there is no spring. Returns: The spring angular target value.

FUParameterFloat& FCDPhysicsRigidConstraint::GetSpringLinearDamping | ( |  | ) | `[inline]`

| Retrieves the spring linear damping of the spring rigid constraint. This is set to 0.0 if there is no spring. Returns: The spring linear damping.

FUParameterFloat& FCDPhysicsRigidConstraint::GetSpringLinearStiffness | ( |  | ) | `[inline]`

| Retrieves the spring linear stiffness of the spring rigid constraint. This is set to 1.0 if there is no spring. Returns: The spring linear stiffness.

FUParameterFloat& FCDPhysicsRigidConstraint::GetSpringLinearTargetValue | ( |  | ) | `[inline]`

| Retrieves the sping linear target value of the spring rigid constraint. This is set to 0.0 if there is no spring. Returns: The spring linear target value.

const fm::string& FCDPhysicsRigidConstraint::GetSubId | ( |  | ) | const`[inline]`

| Retrieves the wanted sub-id for this transform. A wanted sub-id will always be exported, even if the transform is not animated. But the wanted sub-id may be modified if it isn't unique within the scope. Returns: The sub-id.

FCDSceneNode* FCDPhysicsRigidConstraint::GetTargetNode | ( |  | ) | `[inline]`

| Retrieves the attached node which is not the reference. This method should be avoided as the specification says the attachment should be to a rigid body. This value is only used if GetTargetRigidBody is NULL. Returns: The attached non reference node.

FCDPhysicsRigidBody* FCDPhysicsRigidConstraint::GetTargetRigidBody | ( |  | ) | `[inline]`

| Retrieves the attached rigid body which is not the reference. Returns: The non reference rigid body.

FCDTransformContainer& FCDPhysicsRigidConstraint::GetTransformsRef | ( |  | ) | `[inline]`

| Retrieves the transforms for the attached rigid body which is the reference. Returns: The transforms.

FCDTransformContainer& FCDPhysicsRigidConstraint::GetTransformsTar | ( |  | ) | `[inline]`

| Retrieves the transforms for the attached rigid body which is not the reference. Returns: The transforms.

virtual Type FCDPhysicsRigidConstraint::GetType | ( |  | ) | const`[inline, virtual]`

| Retrieves the entity type for this class. This function is part of the FCDEntity interface. Returns: The entity type: PHYSICS_RIGID_CONSTRAINT. Reimplemented from FCDEntity.

void FCDPhysicsRigidConstraint::SetEnabled | ( | bool | _enabled | ) | `[inline]`

  | Sets whether this rigid constraint is enabled. Parameters:
  | _enabled | True of enabled.

void FCDPhysicsRigidConstraint::SetInterpenetrate | ( | bool | _interpenetrate | ) | `[inline]`

  | Sets whether the connected rigid bodies can penetrate eachother. Parameters:
  | _interpenetrate | True of they can penetrate.

void FCDPhysicsRigidConstraint::SetLimitsLinearMax | ( | const FMVector3 & | _limitsLinearMax | ) | `[inline]`

  | Sets the linear max limit of the degrees of freedom. Parameters:
  | _limitsLinearMax | The linear max limit.

void FCDPhysicsRigidConstraint::SetLimitsLinearMin | ( | const FMVector3 & | _limitsLinearMin | ) | `[inline]`

  | Sets the linear min limit of the degrees of freedom. Parameters:
  | _limitsLinearMin | The linear min limit.

void FCDPhysicsRigidConstraint::SetLimitsSCTMax | ( | const FMVector3 & | _limitsSCTMax | ) | `[inline]`

  | Sets the swing cone and twist max limit of the degrees of freedom. Parameters:
  | _limitsSCTMax | The swing cone and twist max limit.

void FCDPhysicsRigidConstraint::SetLimitsSCTMin | ( | const FMVector3 & | _limitsSCTMin | ) | `[inline]`

  | Sets the swing cone and twist min limit of the degrees of freedom. Parameters:
  | _limitsSCTMin | The swing cone and twist min limit.

void FCDPhysicsRigidConstraint::SetReferenceNode | ( | FCDSceneNode * | _referenceNode | ) | `[inline]`

  | Sets the attached node which is the reference. This method should be avoided as the specification says the attachment should be to a rigid body. This value is only used if GetReferenceRigidBody is NULL. Parameters:
  | _referenceNode | The attached reference node.

void FCDPhysicsRigidConstraint::SetReferenceRigidBody | ( | FCDPhysicsRigidBody * | _referenceRigidBody | ) | `[inline]`

  | Sets the attached rigid body which is the reference. Parameters:
  | _referenceRigidBody | The reference rigid body.

void FCDPhysicsRigidConstraint::SetSpringAngularDamping | ( | float | _springAngularDamping | ) | `[inline]`

  | Sets the spring angular damping of the spring rigid constraint. This is set to 0.0 if there is no spring. Parameters:
  | _springAngularDamping | The spring angular damping.

void FCDPhysicsRigidConstraint::SetSpringAngularStiffness | ( | float | _springAngularStiffness | ) | `[inline]`

  | Sets the spring angular stiffness of the spring rigid constraint. This is set to 1.0 if there is no spring. Parameters:
  | _springAngularStiffness | The spring angular stiffness.

void FCDPhysicsRigidConstraint::SetSpringAngularTargetValue | ( | float | _springAngularTargetValue | ) | `[inline]`

  | Sets the sping angular target value of the spring rigid constraint. This is set to 0.0 if there is no spring. Parameters:
  | _springAngularTargetValue | The spring angular target value.

void FCDPhysicsRigidConstraint::SetSpringLinearDamping | ( | float | _springLinearDamping | ) | `[inline]`

  | Sets the spring linear damping of the spring rigid constraint. This is set to 0.0 if there is no spring. Parameters:
  | _springLinearDamping | The spring linear damping.

void FCDPhysicsRigidConstraint::SetSpringLinearStiffness | ( | float | _springLinearStiffness | ) | `[inline]`

  | Sets the spring linear stiffness of the spring rigid constraint. This is set to 1.0 if there is no spring. Parameters:
  | _springLinearStiffness | The spring linear stiffness.

void FCDPhysicsRigidConstraint::SetSpringLinearTargetValue | ( | float | _springLinearTargetValue | ) | `[inline]`

  | Sets the sping linear target value of the spring rigid constraint. This is set to 0.0 if there is no spring. Parameters:
  | _springLinearTargetValue | The spring linear target value.

void FCDPhysicsRigidConstraint::SetSubId | ( | const fm::string & | subId | ) | `[inline]`

  | Sets the wanted sub-id for this transform. A wanted sub-id will always be exported, even if the transform is not animated. But the wanted sub-id may be modified if it isn't unique within the scope. Parameters:
  | subId | The wanted sub-id.

void FCDPhysicsRigidConstraint::SetTargetNode | ( | FCDSceneNode * | _targetNode | ) | `[inline]`

  | Sets the attached node which is not the reference. This method should be avoided as the specification says the attachment should be to a rigid body. This value is only used if GetTargetRigidBody is NULL. Parameters:
  | _targetNode | The attached non reference node.

void FCDPhysicsRigidConstraint::SetTargetRigidBody | ( | FCDPhysicsRigidBody * | _targetRigidBody | ) | `[inline]`

  | Sets the attached rigid body which is not the reference. Parameters:
  | _targetRigidBody | The non reference rigid body.

The documentation for this class was generated from the following file:

- FCDocument/FCDPhysicsRigidConstraint.h